import java.util.ArrayList;
import java.util.Iterator;

public class Studentenverwaltung{
	
	private ArrayList<Student> studenten;
	
	public Studentenverwaltung(){
		studenten = new ArrayList<Student>();
	}
	
	public void hinzufuegen(Student neu){
		this.studenten.add(neu);
	}
	
	public void steuern(){
		setUp();
		Integer ein = -1;
		EinUndAusgabe io = new EinUndAusgabe();
		while(ein !=0){
			io.ausgeben("N\u00e4chste Aktion:\n"
					+ " (0) Programm beenden\n"
					+ " (1) Neuen Studenten einf\u00fcgen\n"
					+ " (2) Student mit Matrikelnummer suchen\n"
					+ " (3) Studierendendaten \u00e4ndern\n"
					+ " (4) Studierende pro Studiengang\n" 
					+ " (5) Student l\u00f6schen\n" 
					+ " (6) Studenten eines Fachs l\u00f6schen\n"
					+ " (7) Neuen Austauschstudenten einf\u00fcgen\n"
					+ " (8) Anzahl Austauschstudenten ausgeben: \n"); // neu
			ein = io.leseInteger();
			switch(ein){
				case 0: {
					break;
				}
				case 1: {
					studentEingeben();
					break;
				}
				case 2: {
					studentSuchen();
					break;
				}
				case 3: {
					studentBearbeiten();
					break;
				}
				case 4: {
					studentenZaehlen();
					break;
				}
				case 5: {                 // neu
					studentLoeschen();
					break;
				}
				case 6: {
					studiengangLoeschen();
					break;
				}
				case 7: {
					austauschstudentenEingeben();
					break;
				}
				case 8: {
					anzahlAustauschstudentenAusgeben();
					break;
				}
				default: {
					io.ausgeben("Zahl zwischen 0 und 8 eingeben\n");
					break;
				}
			}
			io.ausgeben("\n");
		}	
	}
	
    public void setUp(){
    	Student s1 =new Student("Uwe","X",1987,"IMI",424241);
    	Student s2 =new Student("Ute","Y",1988,"IMI",424242);
    	Student s3 =new Student("Ulf","X",1989,"MID",424243);
    	Student s4 =new Student("Uta","B",1987,"MID",424244);
		hinzufuegen(s1);
		hinzufuegen(s2);
		hinzufuegen(s3);
		hinzufuegen(s4);
    }
    
    public void anzahlAustauschstudentenAusgeben(){
    	EinUndAusgabe io = new EinUndAusgabe();
    	io.ausgeben("Es gibt "+ anzahlAustauschstudenten()
    			+ "Austauschstudenten\n");
    }
    
    public Integer anzahlAustauschstudenten(){
    	Integer ergebnis = 0;
    	for(Student s:this.studenten){
    		ergebnis = ergebnis + s.zaehlenAlsAustauschstudent();
    	}
    	return ergebnis;
    }
    
    public Integer anzahlAustauschstudentenNichtSoToll(){
    	Integer ergebnis = 0;
    	for(Student s:this.studenten){
    		if(s instanceof Austauschstudent){
    			ergebnis = ergebnis +1;
    		}
    	}
    	return ergebnis;
    }
    
    public void austauschstudentenEingeben(){
		Austauschstudent ergebnis = new Austauschstudent();
		ergebnis.setVorname(nichtLeererText("Vorname"));
		ergebnis.setNachname(nichtLeererText("Nachname"));
		ergebnis.setStudiengang(nichtLeererText("Studiengang"));
		ergebnis.setGeburtsjahr(zahlZwischen("Geburtsjahr",1900,2000));
		ergebnis.setMatrikelnummer(zahlZwischen("Matrikelnummer",99999,1000000));
		ergebnis.setLand(nichtLeererText("Land"));
		studenten.add(ergebnis);
    }
	
	public void studentLoeschen(){
		Integer mat = zahlZwischen("Matrikelnummer"
				, 99999, 1000000);
		studentloeschen(mat);		
	}
	
    // mit Iterator lschen, recht einfach
	public void studentloeschen(Integer mat) {
		EinUndAusgabe io = new EinUndAusgabe();
		Iterator<Student> it = this.studenten.iterator();
		while(it.hasNext()){
			Student tmp = it.next();
			if(tmp.getMatrikelnummer()== mat){
				it.remove();
				io.ausgeben("Student gel\u00f6scht\n");
			}			
		}
	}
	
	// mit einfacher for-Schleife; kritisch bearbeitete
	// Liste zu ndern, geht aber
	public void studentloeschen2(Integer mat) {
		EinUndAusgabe io = new EinUndAusgabe();
		for(int i=0; i<this.studenten.size(); i++){
			Student tmp = this.studenten.get(i);
			if(tmp.getMatrikelnummer() == mat){
				this.studenten.remove(i);
				io.ausgeben("Student gel\u00f6scht\n");
			}					
		}
	}
	
	// wirft: java.util.ConcurrentModificationException
	public void studentloeschenFalsch(Integer mat) {
		EinUndAusgabe io = new EinUndAusgabe();
		for(Student tmp:this.studenten){
			if(tmp.getMatrikelnummer() == mat){
				this.studenten.remove(tmp);
				io.ausgeben("Student gel\u00f6scht\n");
			}					
		}
	}
	
	public void studentloeschen3(Integer mat) {
		EinUndAusgabe io = new EinUndAusgabe();
		Student weg = null;
		for(Student tmp:this.studenten){
			if(tmp.getMatrikelnummer() == mat){
				weg = tmp;
			}					
		}
		if (weg != null){
			this.studenten.remove(weg);
			io.ausgeben("Student gel\u00f6scht\n");			
		}
	}
	
	public void studiengangLoeschen(){
		EinUndAusgabe io = new EinUndAusgabe();
		String fach = nichtLeererText("Studiengang: ");
		Integer anzahl = studiengangLoeschen(fach);
		io.ausgeben("Es werden "+anzahl+" Studenten gel\u00f6scht\n" );
	}

	public Integer studiengangLoeschen(String fach) {	
		ArrayList<Student> weg = new ArrayList<Student>();
		for(Student tmp:this.studenten){
			if(tmp.getStudiengang().equals(fach)){
				weg.add(tmp);
			}					
		}	
		for(Student tmp:weg){
			this.studenten.remove(tmp);
		}
		return weg.size();
	}
	
	public void studentSuchen(){
		EinUndAusgabe io = new EinUndAusgabe();
		Integer mat = zahlZwischen("Matrikelnummer"
				, 99999, 1000000);
		Student s = studentSuchen(mat);
		if(s != null){
			io.ausgeben("Daten: "+s+"\n");
		} else {
			io.ausgeben("nicht gefunden\n");
		}
	}
	
	public Student studentSuchen(Integer mat){
		Student ergebnis = null;
		for(Student s:this.studenten){
			if(s.getMatrikelnummer() == mat){
				ergebnis = s;
			}
		}
		return ergebnis;
	}
	
	public void studentBearbeiten(){
		EinUndAusgabe io = new EinUndAusgabe();
		Integer mat = zahlZwischen("Matrikelnummer"
				, 99999, 1000000);
		Student s = studentSuchen(mat);
		if(s == null){
			io.ausgeben("nicht gefunden\n");
			return;
		}
		String neuVor = nichtLeererText("neuer Vorname ("
				+"alt:"+s.getVorname()+")");
		String neuNach = nichtLeererText("neuer Nachname ("
				+"alt:"+s.getNachname()+")");
		s.setVorname(neuVor);
		s.setNachname(neuNach);
		io.ausgeben("neu: "+s);
	}
	
	public void studentenZaehlen(){
		EinUndAusgabe io = new EinUndAusgabe();
		String fach = nichtLeererText("Studiengang: ");
		Integer anzahl = studentenZaehlenIn(fach);
		io.ausgeben("in "+fach+": "+anzahl+"\n");	
	}
	
	public Integer studentenZaehlenIn(String fach){
		Integer ergebnis = 0;
		for(Student s:this.studenten){
			if(s.getStudiengang().equals(fach)){
				ergebnis = ergebnis +1;
			}
		}
		return ergebnis;
	}
	
	public Integer anzahl(){
		return this.studenten.size();
	}
	
	/* geht nur, wenn equals sauber umgesetzt
	Boolean exitiertSchon(Student studi){
		return this.studenten.contains(studi);
	}
	*/

	/* erster Versuch
	public Student studentEingeben(){
		Student ergebnis = new Student();
		EinUndAusgabe io = new EinUndAusgabe();
		String tmpVorname = "";
		while(tmpVorname.equals("")){
			io.ausgeben("Vorname: ");
			tmpVorname = io.leseString();
		}
		ergebnis.setVorname(tmpVorname);
		return ergebnis;
	}
	*/
	
	public void studentEingeben(){
		Student ergebnis = new Student();
		ergebnis.setVorname(nichtLeererText("Vorname"));
		ergebnis.setNachname(nichtLeererText("Nachname"));
		ergebnis.setStudiengang(nichtLeererText("Studiengang"));
		ergebnis.setGeburtsjahr(zahlZwischen("Geburtsjahr",1900,2000));
		ergebnis.setMatrikelnummer(zahlZwischen("Matrikelnummer",99999,1000000));
		this.studenten.add(ergebnis);
	}
	
	public String nichtLeererText2(String aufforderung){
		String ergebnis = "";
		EinUndAusgabe io = new EinUndAusgabe();
		while(ergebnis.equals("")){
			io.ausgeben(aufforderung+": ");
			ergebnis = io.leseString();
			ergebnis = ergebnis.trim();
		}
		return ergebnis;
	}
	
	public String nichtLeererText(String aufforderung){
		String ergebnis;
		EinUndAusgabe io = new EinUndAusgabe();
		do{
			io.ausgeben(aufforderung+": ");
			ergebnis = io.leseString();
			ergebnis = ergebnis.trim();
		}while(ergebnis.equals(""));
		return ergebnis;
	}
	
	public Integer zahlZwischen(String aufforderung,
			Integer untereGrenze, Integer obereGrenze ){
		Integer ergebnis = untereGrenze -1;
		EinUndAusgabe io = new EinUndAusgabe();
		while(ergebnis < untereGrenze || ergebnis > obereGrenze){
			io.ausgeben(aufforderung+": ");
			ergebnis = io.leseInteger();
		}
		return ergebnis;
	}
	
	
	public ArrayList<Student> getStudenten() {
		return this.studenten;
	}

	public void setStudenten(ArrayList<Student> studenten) {
		if(studenten != null){
			this.studenten = studenten;
		}
	}

	public static void main(String[] s){
		new Studentenverwaltung().steuern();
	}
	
}
